list markerKeys;
list markerLinks;


markerLinkSet(integer link,
	      string name,
	      vector position,
	      vector color,
	      float alpha)
{
  llMessageLinked(link, 0, 
		  "transform -setPos " + ((string)position.x + " " +
					  (string)position.y + " " +
					  (string)position.z),
		  NULL_KEY);

  llMessageLinked(link, 0, 
		  "texture -setColor " + ((string)color.x + " " +
					  (string)color.y + " " +
					  (string)color.z + " -1 ") +
		  " -setAlpha " + (string)alpha + " -1",
		  NULL_KEY);

  if (name == "")
    name = " ";

  llMessageLinked(link, 0, 
		  "prim -setText " + llEscapeURL(name) + " " +
		  ((string)color.x + " " +
		   (string)color.y + " " +
		   (string)color.z + " " +
		   (string)alpha),
		  NULL_KEY);
}
	      

integer markerFind(string markerKey)
{
  integer i;

  for (i = 0; i < llGetListLength(markerKeys); i++)
    {
      if (llList2String(markerKeys, i) == markerKey)
	return i;
    }
  
  return -1;
}



markerAdd(string markerKey, 
	  string name, 
	  vector position, 
	  vector color)
{
  integer index = markerFind("");

  if (index != -1)
    markerSetIndex(index, markerKey, name, position, color, 1);

}



markerSetIndex(integer index,
	       string markerKey, 
	       string name, 
	       vector position, 
	       vector color,
	       float alpha)
{
  markerKeys = llListReplaceList(markerKeys, [ markerKey ], index, index);
  integer link = llList2Integer(markerLinks, index);
  markerLinkSet(link, name, position, color, alpha);
}


markerSet(string markerKey, 
	  string name, 
	  vector position, 
	  vector color)
{
  integer index = markerFind(markerKey);

  if (index != -1)
    markerSetIndex(index, markerKey, name, position, color, 1);
}



markerRemove(string markerKey)
{
  integer index = markerFind(markerKey);

  if (index != -1)
    markerSetIndex(index, "", "", <0,0,0>, <0,0,0>, 0);
}


markerLoadTable()
{
  integer i;
  for (i = 1; i <= llGetNumberOfPrims(); i++)
    {
      if (llGetLinkName(i) == "marker")
	{
	  markerLinks += [ i ];
	  markerKeys += [ "" ];
	  markerLinkSet(i, "", <0,0,0>, <0,0,0>, 0);
	}
    }
}


initMarker()
{
  markerLoadTable();
}
